#!/usr/bin/bash
set -x
# == General
cd ~/xp
echo Install common dependencies
apt update
apt install -y snapd libforms-dev libforms-bin rsync
snap install yq

# == UHD
echo Install UHD dependencies
apt install -y autoconf automake build-essential ccache cmake cpufrequtils doxygen ethtool g++ git inetutils-tools libboost-all-dev libncurses5 libncurses5-dev libncurses-dev libusb-1.0-0 libusb-1.0-0-dev libusb-dev python3-dev python3-mako python3-numpy python3-requests python3-scipy python3-setuptools python3-ruamel.yaml

echo Build UHD
git clone https://github.com/EttusResearch/uhd.git ~/uhd
cd ~/uhd
git checkout v4.7.0.0
cd host
mkdir build
cd build
cmake ../
make -j $(nproc)
make test
make install
ldconfig
uhd_images_downloader

# == OAI
echo Install OAI dependencies
apt install -y libforms-dev libforms-bin

echo "Clone OpenAirInterface and build gNB"

git clone https://gitlab.eurecom.fr/oai/openairinterface5g.git ~/openairinterface5g
cd ~/openairinterface5g
git checkout develop

cd ~/openairinterface5g/cmake_targets
./build_oai -I

echo build gNB and nrUE
./build_oai -w USRP --ninja --gNB --nrUE --build-lib "nrscope" -C

echo Configure network
cd ~/xp
cp $(hostname -s).netplan.yaml /etc/netplan/50-radio.yaml
netplan generate
netplan apply